; ---------------------------------------------------------------
;-  PB ASM UI (c) 2005-2013, horst.schaeffer@gmx.net
; ---------------------------------------------------------------
#title = "PB Assembler UI  3.10" 
#tempfile = 1
#configfile = 2

IncludeFile "Macro.pbi" 

Global PBsource.s = ProgramParameter() 
Global Compiler.s
CompilerIf #PB_Compiler_Debugger  
  Compiler = #PB_Compiler_Home + "\Compilers\PBCompiler.exe"
CompilerElse 
  Compiler = GetEnvironmentVariable("PB_TOOL_Compiler") 
CompilerEndIf 

If PBsource = "" Or Compiler = ""
  MessageBox_(0,"For IDE integration see PBasmUI.txt","Error",0) : End 
EndIf 

#CPUoffers =  "All CPU,Dynamic CPU,CPU with MMX,CPU with 3DNOW,CPU with SSE,CPU with SSE2" 
#CPUoptions = ",/DYNAMICCPU,/MMX,/3DNOW,/SSE,/SSE2"
#CPUs = 6
; ---------------------------------------------------------------
;- Window  
; ---------------------------------------------------------------
Enumeration 1 ; gadgets
  #compileSource : #PBSourceFile 
  #REASM
  #withIcon : #IconFile : #IconBrowse
  #withResource : #ResourceFile
  
  #produceEXE : #EXEfile : #ExeBrowse
  #WindowsMode : #ConsoleMode : #DLLMode 
  #XPMode : #ASMMode : #OnErrMode 
  #UniMode : #ThreadMode
  #AdminMode : #UserMode
  #DebugMode : #CPUmode
  #Switches
  
  #RunFrame
  #openASMfile : #ViewDefault : #viewASM
  #running 
  #RunButton : #ExitButton
  #RunExe : #autoExit
  
  #ErrorFrame
  #Error : #Etext : #Eclose
EndEnumeration
  
#width = 600 : #height = 470
#flags = #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_Invisible | #PB_Window_ScreenCentered

GuiFont = LoadFont(0,"MS Shell DLG 2",9)
BoldFont = LoadFont(1,"MS Shell DLG 2",9,#PB_Font_Bold)
Global WaitCursor = LoadCursor_(0,#IDC_WAIT)

#wCont = #width-20
Procedure Container(y,height,title.s)
  Shared BoldFont 
  ContainerGadget(#PB_Any,10,y,#wCont,height,#PB_Container_Single)
  tg = TextGadget(#PB_Any,10,5,50,20,title) 
  SetGadgetFont(tg,BoldFont)
EndProcedure 

If OpenWindow(0,50,200,#width,#height,#title,#flags) 
Else: End: EndIf 
  SetGadgetFont(#PB_Default,GuiFont)
  #xIn = 110 
  Container(10,140,"Source")
    OptionGadget(#compileSource,10,25,100,22,"PB file")
    OptionGadget(#REASM,10,50,200,22,"/REASM current ASM file")
      SetGadgetState(#compileSource,1)
    StringGadget(#PBSourceFile,#xIn,25,#wCont-#xIn-10,22,PBsource,#PB_String_ReadOnly)
    CheckBoxGadget(#withIcon,10,75,80,22,"Icon")
    StringGadget(#IconFile,#xIn,75,#wCont-#xIn-45,22,"")
    ButtonGadget(#IconBrowse,#wCont-40,75,30,22,"..")
    CheckBoxGadget(#withResource,10,105,80,22,"Resource")
    StringGadget(#ResourceFile,#xIn,105,#wCont-#xIn-45,22,"")
  CloseGadgetList() 
  
  Container(160,175,"Product")
  #px1 = 40 : #px2 = 160 : #px3 = 330 
  #wx1 = #px2 - #px1 - 10 :  #wx2 = #px3 - #px2 -10 :  #wx3 = #wCont-#px3-10
    CheckBoxGadget(#produceEXE,10,25,100,22, "Executable")
    StringGadget(#EXEfile,#xIn,25,#wCont-#xIn-45,22,"")
    ButtonGadget(#ExeBrowse,#wCont-40,25,30,22,"..")
    OptionGadget(#WindowsMode,#px1,55,#wx1,22,"Windows")
    OptionGadget(#ConsoleMode,#px1,75,#wx1,22,"Console")
    OptionGadget(#DLLMode,#px1,95,#wx1,22,"Shared DLL")
    CheckBoxGadget(#XPMode,#px2,55,#wx2,22,"XP+ theme support")
    CheckBoxGadget(#ASMMode,#px2,75,#wx2,22,"Inline ASM support")
    CheckBoxGadget(#OnErrMode,#px2,95,#wx2,22,"OnError lines support")
    
    CheckBoxGadget(#UniMode,#px3,55,#wx3,22,"Unicode executable")
    CheckBoxGadget(#ThreadMode,#px3,75,#wx3,22,"Threadsafe executable")
    CheckBoxGadget(#AdminMode,#px3,95,#wx3,22,"Request Admin mode")
    CheckBoxGadget(#UserMode,#px3,115,#wx3,22,"Request User mode")
   ; CheckBoxGadget(#OnErrMode,#px2,115,#wx2,22,"OnError lines support")
    
    ComboBoxGadget(#CPUmode,#px1,140,#wx1,24)
      For i = 1 To #CPUs : AddGadgetItem(#CPUmode,-1,StringField(#CPUoffers,i,",")) : Next
      SetGadgetState(#CPUmode,0)
    TextGadget(#PB_Any,#px2,145,#wx2,20,"More Switches..",#PB_Text_Right)
    StringGadget(#Switches,#px3,140,#wx3,24,"")
  CloseGadgetList() 

  ContainerGadget(#ErrorFrame,10,345,#width-20,115,#PB_Container_Single)
    eh = EditorGadget(#Error,0,0,#width-20,88,#PB_Editor_ReadOnly)
    TextGadget(#Etext,10,94,200,20,"")
    ButtonGadget(#Eclose,#width-100,93,75,20,"Ok")
  CloseGadgetList() 
  HideGadget(#ErrorFrame,1)

  ContainerGadget(#RunFrame,10,345,#width-20,115,#PB_Container_Single)
    CheckBoxGadget(#openASMfile,50,10,150,20,"Open PureBasic.asm")
    OptionGadget(#ViewDefault,225,10,100,20,"with Notepad")
    OptionGadget(#viewASM,335,10,100,20,"as .ASM file")
    #bp = 150 
    TextGadget(#running,30,40,100,22,"")
    ButtonGadget(#RunButton,#bp,40,100,25,"Run")
    ButtonGadget(#ExitButton,#bp+120,40,100,25,"Exit")
    CheckBoxGadget(#RunExe,#bp,75,100,20,"Start Program")
    CheckBoxGadget(#autoExit,#bp+120,75,120,20,"Exit when done")
  CloseGadgetList() 
  
Macro ErrorFrameMode(status=#True)
  HideGadget(#RunFrame,status)
  HideGadget(#ErrorFrame,status!1)
EndMacro     
  
Procedure ShowErrorReport(fname.s) 
  ErrorFrameMode(#True)
  ClearGadgetItems(#Error)
  SetGadgetText(#Etext,"Report File: " + GetFilePart(fname))
  If ReadFile(#tempfile,fname)
    bom = ReadStringFormat(#tempfile)
    While Eof(#tempfile) = #False
      AddGadgetItem(#Error,-1,ReadString(#tempfile,bom)) 
    Wend 
    SendMessage_(GadgetID(#Error),#EM_SCROLLCARET,0,0)
    CloseFile(#tempfile)
  EndIf 
  beep()
EndProcedure 

Procedure OptionDependencies()
  x = Bool(GetGadgetState(#compileSource) !1)
  DisableGadget(#PBSourceFile,x)
  DisableGadget(#openASMfile,x)
  If x = 0 : x = Bool(GetGadgetState(#openASMfile) !1) : EndIf 
  DisableGadget(#ViewDefault,x)
  DisableGadget(#viewASM,x)
  
  x = Bool(GetGadgetState(#produceEXE) !1)
  DisableGadget(#EXEfile,x)
  DisableGadget(#ExeBrowse,x)
  x = Bool(GetGadgetState(#withIcon) !1)
  DisableGadget(#IconFile,x)
  DisableGadget(#IconBrowse,x)
  x = Bool(GetGadgetState(#withResource) !1)
  DisableGadget(#ResourceFile,x)
EndProcedure 

; ---------------------------------------------------------------
;- Config Data 
; ---------------------------------------------------------------
#IDEoptions = "IDE Options ="   ; identifies option section 
Global NewList CFGline.s()

Procedure LoadPBconfig()  ; from PBsource or CFG file to list CFGline()
  ConfigSource.s = PBsource             ; default 
  ConfigPrefix.s = "; "
  If FileSize(PBsource + ".cfg") > 0    ; separate CFG file? 
    ConfigSource.s = PBsource + ".cfg"  
    ConfigPrefix = ""
  EndIf 
  Keyword$ = ConfigPrefix + #IDEoptions
  
  If ReadFile(#configfile,ConfigSource) = 0 : ProcedureReturn 0 : EndIf 
  bom = ReadStringFormat(#configfile)
  While Eof(#configfile) = #False 
    line$ = ReadString(#configfile,bom)
    If Left(line$,Len(Keyword$)) = Keyword$ : CFGfound = #True : EndIf 
    If CFGfound ; also for all subsequent lines..
      AddElement(CFGline()) 
      CFGline() = Mid(line$,Len(ConfigPrefix)+1)  ; cut "; " if present
    EndIf 
  Wend 
  CloseFile(#configfile) 
ProcedureReturn CFGfound
EndProcedure 

Procedure.s GetAssignment(IDstring.s)   ; from list CFGlines() - case sensitive!
  ForEach CFGline()
    If Trim(StringField(CFGline(),1,"=")) = IDstring 
      assignedString.s = Trim(StringField(CFGline(),2,"="))
      If assignedString = "" : assignedString = " " : EndIf     ; indicates FOUND but empty
      Break 
    EndIf 
  Next 
ProcedureReturn assignedString 
EndProcedure 

Procedure GetPBconfigData()
  PBsource = FullPath(PBsource)
  SetCurrentDirectory(GetPathPart(PBsource)) 
  If LoadPBconfig()
    
    exeFile.s = GetAssignment("Executable") 
    If exeFile = "" 
      exeFile = GetFilePart(PBsource,#PB_FileSystem_NoExtension) + ".exe"
    EndIf 
    SetGadgetText(#EXEfile,FullPath(exeFile))
    SetGadgetState(#produceEXE,1) 

    format.s = GetAssignment("ExecutableFormat") 
    If format = "Console"        : SetGadgetState(#ConsoleMode,1)
    ElseIf format = "Shared DLL" : SetGadgetState(#DLLMode,1)
    Else                         : SetGadgetState(#WindowsMode,1)
    EndIf 

    CPUmode.s = GetAssignment("CPU")  ; combo box item
    If CPUmode : SetGadgetState(#CPUmode,Val(CPUmode)) : EndIf  
    
    IconFile.s = GetAssignment("UseIcon")
    If IconFile
      IconFile = FullPath(IconFile) 
      SetGadgetText(#IconFile,IconFile)
      SetGadgetState(#withIcon,1) 
    EndIf 
    ResourceFile.s = GetAssignment("AddResource")
    If ResourceFile
      ResourceFile = FullPath(ResourceFile) 
      SetGadgetText(#ResourceFile,ResourceFile)
      SetGadgetState(#withResource,1) 
    EndIf 
    
    If GetAssignment("EnableAsm")  :     SetGadgetState(#ASMMode,1) : EndIf 
    If GetAssignment("EnableXP")  :      SetGadgetState(#XPMode,1) : EndIf 
    If GetAssignment("EnableUnicode") :  SetGadgetState(#UniMode,1) : EndIf 
    If GetAssignment("EnableThread") :   SetGadgetState(#ThreadMode,1) : EndIf 
    If GetAssignment("EnableOnError")  : SetGadgetState(#OnErrMode,1) : EndIf 
    If GetAssignment("EnableAdmin")    : SetGadgetState(#AdminMode,1) : EndIf 
    If GetAssignment("EnableUser")     : SetGadgetState(#UserMode,1) : EndIf 
  EndIf 
  OptionDependencies()
EndProcedure 

; ---------------------------------------------------------------
;- Run Compiler
; ---------------------------------------------------------------
#ASMfile  = "PureBasic.asm"     ; all in Compiler directory
#ASMoutFile = "Assembler.out"
#LinkerFile = "Linker.out"
#Errorfile = "Error.out"

Procedure RunCompiler()
  SetCurrentDirectory(GetPathPart(Compiler)) 
  exeFile.s = GetGadgetText(#EXEfile)
  IconFile.s = GetGadgetText(#IconFile)
  ResourceFile.s = GetGadgetText(#ResourceFile)
  If exeFile = "" : SetGadgetState(#produceEXE,0) : EndIf 
  If IconFile = "" : SetGadgetState(#withIcon,0)  : EndIf 
  If ResourceFile = "" : SetGadgetState(#withResource,0)  : EndIf 
  
  SetCursor_(WaitCursor)
  Parameters.s = "" 
  If GetGadgetState(#compileSource) : Parameters + #q2$+PBsource+#q2$ : EndIf 
  If GetGadgetState(#produceEXE) :   Parameters + " /EXE " + #q2$+exeFile+#q2$ 
  Else                            :  Parameters + " /CHECK "
  EndIf 
  If GetGadgetState(#withIcon) :     Parameters + " /ICON " + #q2$+IconFile+#q2$ : EndIf 
  If GetGadgetState(#withResource) : Parameters + " /RESOURCE " + #q2$+ResourceFile+#q2$ : EndIf 
  
  If GetGadgetState(#ConsoleMode): Parameters + " /CONSOLE"
  ElseIf GetGadgetState(#DLLMode): Parameters + " /DLL"
  EndIf 
  
  Parameters + " " + StringField(#CPUoptions,GetGadgetState(#CPUmode)+1,",") 
  If GetGadgetState(#XPMode) :     Parameters + " /XP" : EndIf 
  If GetGadgetState(#ASMMode) :    Parameters + " /INLINEASM" : EndIf 
  If GetGadgetState(#OnErrMode) :  Parameters + " /LINENUMBERING" : EndIf 
  If GetGadgetState(#UniMode) :    Parameters + " /UNICODE" : EndIf 
  If GetGadgetState(#ThreadMode) : Parameters + " /THREAD" : EndIf 
  If GetGadgetState(#AdminMode)  : Parameters + " /ADMINISTRATOR" : EndIf 
  If GetGadgetState(#UserMode)   : Parameters + " /USER" : EndIf 
  
  If GetGadgetState(#REASM) :      Parameters + " /REASM" 
  Else : DeleteFile(#ASMfile) :    Parameters + " /COMMENTED"
  EndIf 
  s.s = Trim(GetGadgetText(#Switches))
  If s : Parameters + " " + s : EndIf 
  
  DeleteFile(#LinkerFile)
  DeleteFile(#ASMoutFile)
  DeleteFile(#ErrorFile)

  msg.s = "" : ReportFile.s = "" : #buffersize = 40*#KB
  *Buffer = AllocateMemory(#buffersize)
  If *Buffer 
    Process = RunProgram(Compiler,Parameters,"",#PB_Program_Open|#PB_Program_Read) ; #PB_Program_Wait
    If Process 
      ReadSize = ReadProgramData(Process,*Buffer,#buffersize)
      CloseProgram(Process)
      If CreateFile(#tempfile,#ErrorFile)
        WriteData(#tempfile,*Buffer,ReadSize)
        CloseFile(#tempfile) 
        If     FileSize(#ASMoutFile) > 0 : ReportFile = #ASMoutFile
        ElseIf FileSize(#LinkerFile) > 0 : ReportFile = #LinkerFile
        ElseIf FileSize(#ASMfile) <= 0 :   ReportFile = #ErrorFile
        Else : ASMproduced = #True
        EndIf 
      Else : msg = "Cannot catch output"
      EndIf 
    Else : msg = "Cannot run Compiler" 
    EndIf 
    FreeMemory(*Buffer)
  EndIf 
  If msg
    MessageBox_(WindowID(0),msg,"Error",0)
    ProcedureReturn #NUL 
  EndIf 
  
  If ReportFile : ShowErrorReport(ReportFile) : EndIf 
  If ASMproduced 
    prog.s = "Notepad.exe"
    If GetGadgetState(#openASMfile) & GetGadgetState(#compileSource)
      ViewFile.s = FullPath(#ASMfile) 
      If GetGadgetState(#viewASM)
        RunProgram(ViewFile,"","")
      Else 
        RunProgram(prog,#q2$+ViewFile+#q2$,"",0)
      EndIf 
    EndIf 
    If GetGadgetState(#RunExe) And GetGadgetState(#produceEXE)
      RunProgram(exeFile,"",GetPathPart(exeFile),0)
    EndIf 
  EndIf 
ProcedureReturn ASMproduced
EndProcedure 

; ---------------------------------------------------------------
;- FileBrowse
; ---------------------------------------------------------------

Procedure GetIconFile()
  source.s = GetGadgetText(#IconFile)
  If source = "" : source = GetGadgetText(#EXEfile) : EndIf 
  path.s = GetPathPart(source)
  source = OpenFileRequester("Icon",path,"Icon files |*.ico",0)
  If source : SetGadgetText(#IconFile,source) : EndIf 
EndProcedure 

Procedure GetExePath()
  fname.s = GetGadgetText(#EXEfile)
  If fname = "" 
    ln = Len(GetExtensionPart(PBsource))
    fname.s = Left(PBsource,Len(PBsource)-ln-1) + "exe"
  EndIf
  file.s = SaveFileRequester("Executable",fname,"Exe files |*.exe",0)
  If file : SetGadgetText(#EXEfile,file) 
  EndIf 
EndProcedure 

; ---------------------------------------------------------------
;- Main
; ---------------------------------------------------------------
HideWindow(0,0)
DisableGadget(#REASM,Bool(FileSize(#ASMfile) <= 0)) 

; initial states
SetGadgetState(#openASMfile,1)
SetGadgetState(#ViewDefault,0) 
SetGadgetState(#viewASM,1) 
SetGadgetState(#RunExe,0) 
SetGadgetState(#autoExit,1) 
  
GetPBconfigData()

Repeat
  Event = WaitWindowEvent()
  If Event = #PB_Event_Gadget
    Select EventGadget()
    Case #produceEXE
         DisableGadget(#RunExe,Bool(GetGadgetState(#produceEXE))!1)
    Case #IconBrowse : GetIconFile()
    Case #ExeBrowse  : GetExePath()
    Case #RunButton  : done = RunCompiler() & GetGadgetState(#autoExit)
         DisableGadget(#REASM,Bool(FileSize(#ASMfile) <= 0)) 
    Case #ExitButton : done = #True
    Case #Eclose : ErrorFrameMode(#False)
    Default : OptionDependencies()
    EndSelect 
  ElseIf Event = #PB_Event_CloseWindow : done = #True
  EndIf 
Until done
End

; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 99
; FirstLine = 66
; Folding = --
; EnableUnicode
; EnableXP
; UseIcon = pb5.ico
; Executable = PBasmUI.exe
; CommandLine = PBasmUI.pb
; CompileSourceDirectory
; IncludeVersionInfo
; VersionField0 = 3,1,0,0
; VersionField1 = 3,1,0,0
; VersionField2 = Horst Schaeffer
; VersionField3 = PBasmUI
; VersionField4 = 3.1,  %yyyy-%mm-%dd
; VersionField5 = 3.1
; VersionField7 = PBasmUI
; VersionField8 = PBasmUI.exe
; VersionField9 = 2004-%yyyy, Horst Schaeffer
; VersionField15 = VOS_DOS_WINDOWS32
; VersionField16 = VFT_APP